#include <windows.h>
#include <alchemw.h>
#include "resource.h"

#define INIT	0
#define QUIT	1

typedef struct tagDataStruct {
	char szFirst[21];
	char szLast[21];
} DATASTRUCT;

int 	WINAPI _export LibMain(HINSTANCE,WORD,WORD,LPSTR);
int 	WINAPI _export WEP(int);
void 	WINAPI _export PlugDestroy(LPSLOT);
WORD 	WINAPI _export PlugType(LPSLOT,LPSTR);
WORD 	WINAPI _export PlugProcess(LPSLOT);
BOOL 	WINAPI _export PlugUnique(LPSLOT,LPCSTR,LPSTR);
WORD	WINAPI _export PlugDialog(LPSLOT,WORD);
WORD 	WINAPI _export PlugButton(LPSLOT,WORD);
BOOL 	WINAPI _export PlugData(LPSLOT,BOOL,void FAR *);
BOOL 	WINAPI _export PlugMouse(LPSLOT,BYTE,WORD,WORD);
void	WINAPI _export PlugActivate(LPSLOT,BOOL);
void	WINAPI _export PlugPaint(LPSLOT,HDC,BOOL,RECT*);
void	WINAPI _export PlugResize(LPSLOT,WORD,WORD);

void GetUserInfo(LPSLOT);
void ShowUserInfo(LPSLOT);

#pragma argsused
int WINAPI _export LibMain(HINSTANCE hInstance,WORD wDataSegment,WORD wHeapSize,LPSTR lpszCmdLine ) {
	return TRUE;
}
#pragma argsused
int WINAPI _export WEP(int bSystemExit) {
	return 1;
}
#pragma argsused
void WINAPI _export PlugActivate(LPSLOT lpSlot,BOOL activate) {
	return;
}
#pragma argsused
void WINAPI _export PlugPaint(LPSLOT lpSlot,HDC dc,BOOL erase,RECT *rect){
	return;
}
#pragma argsused
void WINAPI _export PlugResize(LPSLOT lpSlot,WORD width,WORD height) {
	return;
}
#pragma argsused
BOOL WINAPI _export PlugUnique(LPSLOT lpSlot,LPCSTR args,LPSTR message) {
	return TRUE;
}
#pragma argsused
BOOL WINAPI _export PlugMouse(LPSLOT lpSlot,BYTE code,WORD x,WORD y) {
	return AL_IDLE;
}
#pragma argsused
BOOL WINAPI _export PlugData(LPSLOT lpSlot,BOOL more,void FAR *data) {
	return FALSE;
}
#pragma argsused
WORD WINAPI _export PlugDialog(LPSLOT lpSlot,WORD result) {
	return AL_IDLE;
}
#pragma argsused
WORD WINAPI _export PlugButton(LPSLOT lpSlot,WORD id) {
	return AL_IDLE;
}
#pragma argsused
WORD WINAPI _export PlugType(LPSLOT lpSlot,LPSTR title) {

	AlAlloc(lpSlot,42);
	AlCaption(lpSlot,"Plug-In : JDS Sample Plug-In");
	AlLogWrite(lpSlot,"Entering JDS Sample Plug-In");
	return AL_WIN_HIDDEN;
}
#pragma argsused
WORD WINAPI _export PlugProcess(LPSLOT lpSlot) {

	WORD nState;
	WORD nRetVal;

	nRetVal = AL_IDLE;
	nState = AlGetState(lpSlot);
	switch (nState) {
		case INIT:
			GetUserInfo(lpSlot);
			AlSetState(lpSlot,QUIT);
			nRetVal = AL_OK;
		break;
		case QUIT:
			ShowUserInfo(lpSlot);
			nRetVal = AL_DIE;
		break;
	}
	return nRetVal;
}
#pragma argsused
void WINAPI _export PlugDestroy(LPSLOT lpSlot ) {

	AlLogWrite(lpSlot,"Leaving JDS Sample Plug-In");
	AlFree(lpSlot);
}

#pragma argsused
void GetUserInfo(LPSLOT lpSlot) {

	DATASTRUCT * ds;

	ds = (DATASTRUCT *) AlLock(lpSlot);
	AlGetUserFirst(lpSlot,ds->szFirst,21);
	AlGetUserLast(lpSlot,ds->szLast,21);
	AlUnlock(lpSlot);
}

#pragma argsused
void ShowUserInfo(LPSLOT lpSlot) {

	DATASTRUCT * ds;
	char szArgs[80];

	AlArgs(lpSlot,szArgs,80);
	AlLogWrite(lpSlot,szArgs);
	ds = (DATASTRUCT *) AlLock(lpSlot);
	AlLogWrite(lpSlot,ds->szFirst);
	AlLogWrite(lpSlot,ds->szLast);
	AlUnlock(lpSlot);
}
